#!/usr/bin/env python3

import json
import sys
from requests import get
from requests.auth import HTTPBasicAuth

if __name__ == "__main__":
	channel_params = {'url': 'stream-info', 'json_obj': 'streams'}
	dvb_params = {'url': 'adapter-info', 'json_obj': 'adapters'}

	ports_list = sys.argv[1]
	astra_user = sys.argv[2]
	astra_pwd = sys.argv[3]
	if sys.argv[4] == 'stream':
		act_dict = channel_params
	elif sys.argv[4] == "dvb":
		act_dict = dvb_params
	else:
		sys.exit(1)

	ports = ports_list.split(",")
	data = {}
	chs = []
	for port in ports:
		try:
			r = get("http://127.0.0.1:{}/api/{}".format(port, act_dict['url']), timeout = 15, auth = HTTPBasicAuth(astra_user, astra_pwd))
			js0n = r.json()
			instance = js0n['instance']
			for i in js0n[act_dict['json_obj']]:
				if i['enable']:
					ch = {}
					ch['{#ID}'] = i['id']
					ch['{#NAME}'] = i['name']
					ch['{#PORT}'] = port
					ch['{#INSTANCE}'] = instance
					chs.append(ch)
		except:
			pass
	data['data'] = chs
	print(json.dumps(data, ensure_ascii=False))
